Index: palm/trunk/SOURCE/transpose.f90
===================================================================
--- palm/trunk/SOURCE/transpose.f90	(revision 4901)
+++ palm/trunk/SOURCE/transpose.f90	(revision 1)
@@ -63,629 +43,287 @@
 ! Description:
 ! ------------
-!> Resorting data for the transposition from x to y. The transposition itself is carried out in
-!> transpose_xy.
-!--------------------------------------------------------------------------------------------------!
-
-#define __acc_fft_device ( defined( _OPENACC ) && ( defined ( __cuda_fft ) ) )
-
- SUBROUTINE resort_for_xy( f_in, f_inv )
-
-
-    USE indices,                                                                                   &
-        ONLY:  nx
-
-    USE kinds
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nyn_x,                                                                              &
-               nys_x,                                                                              &
-               nzb_x,                                                                              &
-               nzt_x
+! Transposition of input array (f_in) from x to y. For the input array, all
+! elements along x reside on the same PE, while after transposition, all
+! elements along y reside on the same PE.
+!------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE transpose_indices
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-    REAL(wp) ::  f_in(0:nx,nys_x:nyn_x,nzb_x:nzt_x)   !<
-    REAL(wp) ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx)  !<
-
-!
-!-- Rearrange indices of input array in order to make data to be send by MPI contiguous
-    !$OMP  PARALLEL PRIVATE ( i, j, k )
-    !$OMP  DO
-#if __acc_fft_device
-    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-    !$ACC PRESENT(f_inv, f_in)
+    INTEGER ::  i, j, k, l, m, ys
+    
+    REAL ::  f_in(0:nxa,nys_x:nyn_xa,nzb_x:nzt_xa),                     &
+             f_inv(nys_x:nyn_xa,nzb_x:nzt_xa,0:nxa),                    &
+             f_out(0:nya,nxl_y:nxr_ya,nzb_y:nzt_ya),                    &
+             work1(nys_x:nyn_xa,nzb_x:nzt_xa,0:nxa), work2(nnx*nny*nnz)
+
+#if defined( __parallel )
+
+!
+!-- Rearrange indices of input array in order to make data to be send
+!-- by MPI contiguous
+    DO  k = nzb_x, nzt_xa
+       DO  j = nys_x, nyn_xa
+          DO  i = 0, nxa
+             work1(j,k,i) = f_in(i,j,k)
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Move data to different array, because memory location of work1 is
+!-- needed further below (work1 = work2)
+    DO  i = 0, nxa
+       DO  k = nzb_x, nzt_xa
+          DO  j = nys_x, nyn_xa
+             f_inv(j,k,i) = work1(j,k,i)
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Transpose array
+    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+    CALL MPI_ALLTOALL( f_inv(nys_x,nzb_x,0), sendrecvcount_xy, MPI_REAL, &
+                       work2(1),             sendrecvcount_xy, MPI_REAL, &
+                       comm1dy, ierr )
+    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!-- Reorder transposed array
+    m = 0
+    DO  l = 0, pdims(2) - 1
+       ys = 0 + l * ( nyn_xa - nys_x + 1 )
+       DO  i = nxl_y, nxr_ya
+          DO  k = nzb_y, nzt_ya
+             DO  j = ys, ys + nyn_xa - nys_x
+                m = m + 1
+                f_out(j,i,k) = work2(m)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDDO
+
 #endif
-    DO  k = nzb_x, nzt_x
-        DO  j = nys_x, nyn_x
-            DO  i = 0, nx
-               f_inv(j,k,i) = f_in(i,j,k)
-            ENDDO
-        ENDDO
-    ENDDO
-    !$OMP  END PARALLEL
-
- END SUBROUTINE resort_for_xy
-
-
-!--------------------------------------------------------------------------------------------------!
+
+ END SUBROUTINE transpose_xy
+
+
+ SUBROUTINE transpose_xz( f_in, work1, f_inv, work2, f_out )
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Transposition of input array (f_in) from x to y. For the input array, all elements along x reside
-!> on the same PE, while after transposition, all elements along y reside on the same PE.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE transpose_xy( f_inv, f_out )
-
+! Transposition of input array (f_in) from x to z. For the input array, all
+! elements along x reside on the same PE, while after transposition, all
+! elements along z reside on the same PE.
+!------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE transpose_indices
+
+    IMPLICIT NONE
+
+    INTEGER ::  i, j, k, l, m, xs
+    
+    REAL ::  f_in(0:nxa,nys_x:nyn_xa,nzb_x:nzt_xa),             &
+             f_inv(nxl:nxra,nys:nyna,1:nza),                    &
+             f_out(1:nza,nys:nyna,nxl:nxra),                    &
+             work1(1:nza,nys:nyna,nxl:nxra), work2(nnx*nny*nnz)
 
 #if defined( __parallel )
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               cpu_log_nowait,                                                                     &
-               log_point_s
+
+!
+!-- If the PE grid is one-dimensional along y, the array has only to be
+!-- reordered locally and therefore no transposition has to be done.
+    IF ( pdims(1) /= 1 )  THEN
+!
+!--    Reorder input array for transposition
+       m = 0
+       DO  l = 0, pdims(1) - 1
+          xs = 0 + l * nnx
+          DO  k = nzb_x, nzt_xa
+             DO  j = nys_x, nyn_xa
+                DO  i = xs, xs + nnx - 1
+                   m = m + 1
+                   work2(m) = f_in(i,j,k)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+
+!
+!--    Transpose array
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+       CALL MPI_ALLTOALL( work2(1),         sendrecvcount_zx, MPI_REAL, &
+                          f_inv(nxl,nys,1), sendrecvcount_zx, MPI_REAL, &
+                          comm1dx, ierr )
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!--    Reorder transposed array in a way that the z index is in first position
+       DO  i = nxl, nxra
+          DO  j = nys, nyna
+             DO  k = 1, nza
+                work1(k,j,i) = f_inv(i,j,k)
+             ENDDO
+          ENDDO
+       ENDDO
+    ELSE
+!
+!--    Reorder the array in a way that the z index is in first position
+       DO  i = nxl, nxra
+          DO  j = nys, nyna
+             DO  k = 1, nza
+                work1(k,j,i) = f_in(i,j,k)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+!
+!-- Move data to output array
+    DO  i = nxl, nxra
+       DO  j = nys, nyna
+          DO  k = 1, nza
+             f_out(k,j,i) = work1(k,j,i)
+          ENDDO
+       ENDDO
+    ENDDO
+
 #endif
 
-    USE indices,                                                                                   &
-        ONLY:  nx,                                                                                 &
-               ny
-
-    USE kinds
-
-    USE pegrid
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_y,                                                                              &
-               nxr_y,                                                                              &
-               nyn_x,                                                                              &
-               nys_x,                                                                              &
-               nzb_x,                                                                              &
-               nzb_y,                                                                              &
-               nzt_x,                                                                              &
-               nzt_y
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-#if defined( __parallel )
-    INTEGER(iwp) ::  l   !<
-    INTEGER(iwp) ::  ys  !<
-#endif
-
-    REAL(wp) ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx)  !<
-    REAL(wp) ::  f_out(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)  !<
-
-#if defined( __parallel )
-    REAL(wp), DIMENSION(nyn_x-nys_x+1,nzb_y:nzt_y,nxl_y:nxr_y,0:pdims(2)-1) ::  work  !<
-#if __acc_fft_device
-    !$ACC DECLARE CREATE(work)
-#endif
-#endif
-
-
-    IF ( numprocs /= 1 )  THEN
-
-#if defined( __parallel )
-!
-!--    Transpose array
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE HOST(f_inv)
-#else
-       !$ACC HOST_DATA USE_DEVICE(work, f_inv)
-#endif
-#endif
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLTOALL( f_inv(nys_x,nzb_x,0),  sendrecvcount_xy, MPI_REAL,                       &
-                          work(1,nzb_y,nxl_y,0), sendrecvcount_xy, MPI_REAL, comm1dy, ierr )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE DEVICE(work)
-#else
-       !$ACC END HOST_DATA
-#endif
-#endif
-
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-
-!
-!--    Reorder transposed array
-       !$OMP  PARALLEL PRIVATE ( i, j, k, l, ys )
-       DO  l = 0, pdims(2) - 1
-          ys = 0 + l * ( nyn_x - nys_x + 1 )
-#if __acc_fft_device
-          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-          !$ACC PRESENT(f_out, work)
-#endif
-          !$OMP DO
-          DO  i = nxl_y, nxr_y
-             DO  k = nzb_y, nzt_y
-                DO  j = ys, ys + nyn_x - nys_x
-                   f_out(j,i,k) = work(j-ys+1,k,i,l)
-                ENDDO
-             ENDDO
-          ENDDO
-          !$OMP END DO NOWAIT
-       ENDDO
-       !$OMP  END PARALLEL
-#endif
-
-    ELSE
-
-!
-!--    Reorder transposed array
-       !$OMP  PARALLEL PRIVATE ( i, j, k )
-       !$OMP  DO
-#if __acc_fft_device
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-       !$ACC PRESENT(f_out, f_inv)
-#endif
-       DO  k = nzb_y, nzt_y
-          DO  i = nxl_y, nxr_y
-             DO  j = 0, ny
-                f_out(j,i,k) = f_inv(j,k,i)
-             ENDDO
-          ENDDO
-       ENDDO
-       !$OMP  END PARALLEL
-
-    ENDIF
-
- END SUBROUTINE transpose_xy
-
-
-!--------------------------------------------------------------------------------------------------!
+ END SUBROUTINE transpose_xz
+
+
+ SUBROUTINE transpose_yx( f_in, work1, f_inv, work2, f_out )
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Resorting data after the transposition from x to z. The transposition itself is carried out in
-!> transpose_xz.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE resort_for_xz( f_inv, f_out )
-
-
-    USE indices,                                                                                   &
-        ONLY:  nxl,                                                                                &
-               nxr,                                                                                &
-               nyn,                                                                                &
-               nys,                                                                                &
-               nz
-
-    USE kinds
+! Transposition of input array (f_in) from y to x. For the input array, all
+! elements along y reside on the same PE, while after transposition, all
+! elements along x reside on the same PE.
+!------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE transpose_indices
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-    REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz)  !<
-    REAL(wp) ::  f_out(1:nz,nys:nyn,nxl:nxr)  !<
-
-!
-!-- Rearrange indices of input array in order to make data to be send by MPI contiguous.
-!-- In case of parallel fft/transposition, scattered store is faster in backward direction!!!
-    !$OMP  PARALLEL PRIVATE ( i, j, k )
-    !$OMP  DO
-#if __acc_fft_device
-    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-    !$ACC PRESENT(f_out, f_inv)
+    INTEGER ::  i, j, k, l, m, ys
+    
+    REAL ::  f_in(0:nya,nxl_y:nxr_ya,nzb_y:nzt_ya),                     &
+             f_inv(nys_x:nyn_xa,nzb_x:nzt_xa,0:nxa),                    &
+             f_out(0:nxa,nys_x:nyn_xa,nzb_x:nzt_xa),                    &
+             work1(0:nxa,nys_x:nyn_xa,nzb_x:nzt_xa), work2(nnx*nny*nnz)
+
+#if defined( __parallel )
+
+!
+!-- Reorder input array for transposition
+    m = 0
+    DO  l = 0, pdims(2) - 1
+       ys = 0 + l * ( nyn_xa - nys_x + 1 )
+       DO  i = nxl_y, nxr_ya
+          DO  k = nzb_y, nzt_ya
+             DO  j = ys, ys + nyn_xa - nys_x
+                m = m + 1
+                work2(m) = f_in(j,i,k)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Transpose array
+    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+    CALL MPI_ALLTOALL( work2(1),             sendrecvcount_xy, MPI_REAL, &
+                       f_inv(nys_x,nzb_x,0), sendrecvcount_xy, MPI_REAL, &
+                       comm1dy, ierr )
+    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!-- Reorder transposed array in a way that the x index is in first position
+    DO  i = 0, nxa
+       DO  k = nzb_x, nzt_xa
+          DO  j = nys_x, nyn_xa
+             work1(i,j,k) = f_inv(j,k,i)
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Move data to output array
+    DO  k = nzb_x, nzt_xa
+       DO  j = nys_x, nyn_xa
+          DO  i = 0, nxa
+             f_out(i,j,k) = work1(i,j,k)
+          ENDDO
+       ENDDO
+    ENDDO
+
 #endif
-    DO  i = nxl, nxr
-        DO  j = nys, nyn
-            DO  k = 1, nz
-               f_out(k,j,i) = f_inv(j,i,k)
-            ENDDO
-        ENDDO
-    ENDDO
-    !$OMP  END PARALLEL
-
- END SUBROUTINE resort_for_xz
-
-
-!--------------------------------------------------------------------------------------------------!
+
+ END SUBROUTINE transpose_yx
+
+
+ SUBROUTINE transpose_yxd( f_in, work1, f_inv, work2, f_out )
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Transposition of input array (f_in) from x to z. For the input array, all elements along x reside
-!> on the same PE, while after transposition, all elements along z reside on the same PE.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE transpose_xz( f_in, f_inv )
+! Transposition of input array (f_in) from y to x. For the input array, all
+! elements along y reside on the same PE, while after transposition, all
+! elements along x reside on the same PE.
+! This is a direct transposition for arrays with indices in regular order
+! (k,j,i) (cf. transpose_yx).
+!------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE transpose_indices
+
+    IMPLICIT NONE
+
+    INTEGER ::  i, j, k, l, m, recvcount_yx, sendcount_yx, xs
+
+    REAL ::  f_in(1:nza,nys:nyna,nxl:nxra), f_inv(nxl:nxra,1:nza,nys:nyna), &
+             f_out(0:nxa,nys_x:nyn_xa,nzb_x:nzt_xa),                        &
+             work1(nxl:nxra,1:nza,nys:nyna), work2(nnx*nny*nnz)
 
 #if defined( __parallel )
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               cpu_log_nowait,                                                                     &
-               log_point_s
-
-    USE fft_xy,                                                                                    &
-        ONLY:  f_vec_x,                                                                            &
-               temperton_fft_vec
-#endif
-
-    USE indices,                                                                                   &
-        ONLY:  nx,                                                                                 &
-               nxl,                                                                                &
-               nxr,                                                                                &
-               nyn,                                                                                &
-               nys,                                                                                &
-               nz
-
-#if defined( __parallel )
-    USE indices,                                                                                   &
-        ONLY:  nnx
-#endif
-
-    USE kinds
-
-    USE pegrid
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nyn_x,                                                                              &
-               nys_x,                                                                              &
-               nzb_x,                                                                              &
-               nzt_x
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-#if defined( __parallel )
-    INTEGER(iwp) ::  l   !<
-    INTEGER(iwp) ::  mm  !<
-    INTEGER(iwp) ::  xs  !<
-#endif
-
-    REAL(wp) ::  f_in(0:nx,nys_x:nyn_x,nzb_x:nzt_x)  !<
-    REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz)         !<
-
-#if defined( __parallel )
-    REAL(wp), DIMENSION(nys_x:nyn_x,nnx,nzb_x:nzt_x,0:pdims(1)-1) ::  work  !<
-#if __acc_fft_device
-    !$ACC DECLARE CREATE(work)
-#endif
-#endif
-
-    !
-    !-- If the PE grid is one-dimensional along y, the array has only to be reordered locally and
-    !-- therefore no transposition has to be done.
-    IF ( pdims(1) /= 1 )  THEN
-
-#if defined( __parallel )
-!
-!--    Reorder input array for transposition. Data from the vectorized Temperton-fft is stored in
-!--    different array format (f_vec_x).
-       IF ( temperton_fft_vec )  THEN
-
-          DO  l = 0, pdims(1) - 1
-             xs = 0 + l * nnx
-             DO  k = nzb_x, nzt_x
-                DO  i = xs, xs + nnx - 1
-                   DO  j = nys_x, nyn_x
-                      mm = j-nys_x+1+(k-nzb_x)*(nyn_x-nys_x+1)
-                      work(j,i-xs+1,k,l) = f_vec_x(mm,i)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDDO
-
-       ELSE
-
-          !$OMP  PARALLEL PRIVATE ( i, j, k, l, xs )
-          DO  l = 0, pdims(1) - 1
-             xs = 0 + l * nnx
-#if __acc_fft_device
-             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-             !$ACC PRESENT(work, f_in)
-#endif
-             !$OMP DO
-             DO  k = nzb_x, nzt_x
-                DO  i = xs, xs + nnx - 1
-                   DO  j = nys_x, nyn_x
-                      work(j,i-xs+1,k,l) = f_in(i,j,k)
-                   ENDDO
-                ENDDO
-             ENDDO
-             !$OMP END DO NOWAIT
-          ENDDO
-          !$OMP  END PARALLEL
-
-       ENDIF
-
-!
-!--    Transpose array
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE HOST(work)
-#else
-       !$ACC HOST_DATA USE_DEVICE(work, f_inv)
-#endif
-#endif
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLTOALL( work(nys_x,1,nzb_x,0), sendrecvcount_zx, MPI_REAL,                       &
-                          f_inv(nys,nxl,1),      sendrecvcount_zx, MPI_REAL, comm1dx, ierr )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE DEVICE(f_inv)
-#else
-       !$ACC END HOST_DATA
-#endif
-#endif
-
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-#endif
-
-    ELSE
-
-!
-!--    Reorder the array in a way that the z index is in first position
-       !$OMP PARALLEL PRIVATE ( i, j, k )
-       !$OMP DO
-#if __acc_fft_device
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-       !$ACC PRESENT(f_inv, f_in)
-#endif
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = 1, nz
-                f_inv(j,i,k) = f_in(i,j,k)
-             ENDDO
-          ENDDO
-       ENDDO
-       !$OMP END PARALLEL
-
-    ENDIF
-
- END SUBROUTINE transpose_xz
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Resorting data after the transposition from y to x. The transposition itself is carried out in
-!> transpose_yx.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE resort_for_yx( f_inv, f_out )
-
-
-    USE indices,                                                                                   &
-        ONLY:  nx
-
-    USE kinds
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nyn_x,                                                                              &
-               nys_x,                                                                              &
-               nzb_x,                                                                              &
-               nzt_x
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-    REAL(wp) ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx)  !<
-    REAL(wp) ::  f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x)  !<
-
-!
-!-- Rearrange indices of input array in order to make data to be send by MPI contiguous.
-   !$OMP PARALLEL PRIVATE ( i, j, k )
-   !$OMP DO
-#if __acc_fft_device
-   !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-   !$ACC PRESENT(f_out, f_inv)
-#endif
-    DO  k = nzb_x, nzt_x
-        DO  j = nys_x, nyn_x
-            DO  i = 0, nx
-               f_out(i,j,k) = f_inv(j,k,i)
-            ENDDO
-        ENDDO
-    ENDDO
-    !$OMP END PARALLEL
-
- END SUBROUTINE resort_for_yx
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Transposition of input array (f_in) from y to x. For the input array, all  elements along y
-!> reside on the same PE, while after transposition, all elements along x reside on the same PE.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE transpose_yx( f_in, f_inv )
-
-
-#if defined( __parallel )
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               cpu_log_nowait,                                                                     &
-               log_point_s
-#endif
-
-    USE indices,                                                                                   &
-        ONLY:  nx,                                                                                 &
-               ny
-
-    USE kinds
-
-    USE pegrid
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_y,                                                                              &
-               nxr_y,                                                                              &
-               nyn_x,                                                                              &
-               nys_x,                                                                              &
-               nzb_x,                                                                              &
-               nzb_y,                                                                              &
-               nzt_x,                                                                              &
-               nzt_y
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-#if defined( __parallel )
-    INTEGER(iwp) ::  l   !<
-    INTEGER(iwp) ::  ys  !<
-#endif
-
-    REAL(wp) ::  f_in(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)   !<
-    REAL(wp) ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx)  !<
-
-#if defined( __parallel )
-    REAL(wp), DIMENSION(nyn_x-nys_x+1,nzb_y:nzt_y,nxl_y:nxr_y,0:pdims(2)-1) ::  work  !<
-#if __acc_fft_device
-    !$ACC DECLARE CREATE(work)
-#endif
-#endif
-
-
-    IF ( numprocs /= 1 )  THEN
-
-#if defined( __parallel )
-!
-!--    Reorder input array for transposition
-       !$OMP PARALLEL PRIVATE ( i, j, k, l, ys )
-       DO  l = 0, pdims(2) - 1
-          ys = 0 + l * ( nyn_x - nys_x + 1 )
-#if __acc_fft_device
-          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-          !$ACC PRESENT(work, f_in)
-#endif
-          !$OMP DO
-          DO  i = nxl_y, nxr_y
-             DO  k = nzb_y, nzt_y
-                DO  j = ys, ys + nyn_x - nys_x
-                   work(j-ys+1,k,i,l) = f_in(j,i,k)
-                ENDDO
-             ENDDO
-          ENDDO
-          !$OMP END DO NOWAIT
-       ENDDO
-       !$OMP END PARALLEL
-
-!
-!--    Transpose array
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE HOST(work)
-#else
-       !$ACC HOST_DATA USE_DEVICE(work, f_inv)
-#endif
-#endif
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLTOALL( work(1,nzb_y,nxl_y,0), sendrecvcount_xy, MPI_REAL,                       &
-                          f_inv(nys_x,nzb_x,0),  sendrecvcount_xy, MPI_REAL, comm1dy, ierr )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE DEVICE(f_inv)
-#else
-       !$ACC END HOST_DATA
-#endif
-#endif
-
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-#endif
-
-    ELSE
-
-!
-!--    Reorder array f_in the same way as ALLTOALL did it.
-       !$OMP PARALLEL PRIVATE ( i, j, k )
-       !$OMP DO
-#if __acc_fft_device
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-       !$ACC PRESENT(f_inv, f_in)
-#endif
-       DO  i = nxl_y, nxr_y
-          DO  k = nzb_y, nzt_y
-             DO  j = 0, ny
-                f_inv(j,k,i) = f_in(j,i,k)
-             ENDDO
-          ENDDO
-       ENDDO
-       !$OMP END PARALLEL
-
-    ENDIF
-
- END SUBROUTINE transpose_yx
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Transposition of input array (f_in) from y to x. For the input array, all elements along y reside
-!> on the same PE, while after transposition, all elements along x reside on the same PE. This is a
-!> direct transposition for arrays with indices in regular order (k,j,i) (cf. transpose_yx).
-!--------------------------------------------------------------------------------------------------!
-#if defined( __parallel )
- SUBROUTINE transpose_yxd( f_in, f_out )
-
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               log_point_s
-
-    USE indices,                                                                                   &
-        ONLY:  nnx,                                                                                &
-               nny,                                                                                &
-               nnz,                                                                                &
-               nx,                                                                                 &
-               nxl,                                                                                &
-               nxr,                                                                                &
-               nyn,                                                                                &
-               nys,                                                                                &
-               nz
-
-    USE kinds
-
-    USE pegrid
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nyn_x,                                                                              &
-               nys_x,                                                                              &
-               nzb_x,                                                                              &
-               nzt_x
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i   !<
-    INTEGER(iwp) ::  j   !<
-    INTEGER(iwp) ::  k   !<
-    INTEGER(iwp) ::  l   !<
-    INTEGER(iwp) ::  m   !<
-    INTEGER(iwp) ::  xs  !<
-
-    REAL(wp) ::  f_in(1:nz,nys:nyn,nxl:nxr)           !<
-    REAL(wp) ::  f_inv(nxl:nxr,1:nz,nys:nyn)          !<
-    REAL(wp) ::  f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x)  !<
-    REAL(wp) ::  work(nnx*nny*nnz)                    !<
-
-!
-!-- Rearrange indices of input array in order to make data to be send by MPI contiguous.
-    DO  k = 1, nz
-       DO  j = nys, nyn
-          DO  i = nxl, nxr
-             f_inv(i,k,j) = f_in(k,j,i)
+
+!
+!-- Rearrange indices of input array in order to make data to be send
+!-- by MPI contiguous
+    DO  k = 1, nza
+       DO  j = nys, nyna
+          DO  i = nxl, nxra
+             work1(i,k,j) = f_in(k,j,i)
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Move data to different array, because memory location of work1 is
+!-- needed further below (work1 = work2)
+    DO  j = nys, nyna
+       DO  k = 1, nza
+          DO  i = nxl, nxra
+             f_inv(i,k,j) = work1(i,k,j)
           ENDDO
        ENDDO
@@ -695,7 +333,7 @@
 !-- Transpose array
     CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLTOALL( f_inv(nxl,1,nys), sendrecvcount_xy, MPI_REAL,                               &
-                       work(1), sendrecvcount_xy, MPI_REAL, comm1dx, ierr )
+    CALL MPI_ALLTOALL( f_inv(nxl,1,nys), sendrecvcount_xy, MPI_REAL, &
+                       work2(1),         sendrecvcount_xy, MPI_REAL, &
+                       comm1dx, ierr )
     CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
 
